\documentclass[a4paper, hole]{tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Tuto minidem}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien

\begin{document}
\renewcommand{\labelitemi}{$\bullet$}

\newdemexo{01}{basics of minidem}

\noindent The objective of this tutorial is to familiarize yourself with the
minidem module. This tutorial shows the use of the \texttt{main} block
to define the initial conditions of a simulation. In this example, only the
\textit{Velocity Verlet} algorithm is implemented. Collision detection is not taken into account.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{01}{tuto-01\_exercice.py}. Run the script
  \dltutodem{01}{tuto-01\_exercice.py}.
\end{task}

\begin{info}
At this stage, you should obtain a simulation similar to the video \dltutodem{01}{tuto-01\_exercice.mp4}.
\end{info}

\begin{task}
  Understand the structure of this script by answering the following questions.
  \begin{enumerate}
  \item What are the roles of the variables \texttt{dem.simu.t} and \texttt{dem.simu.dt}?
  \item What is the role of the \texttt{main} code block?
  \item What are the initial position and velocity of the \texttt{grain}?
  \end{enumerate}
\end{task}

\begin{task}
  Using the built-in \texttt{print()} function, display the elapsed time
  during the simulation in the terminal.
\end{task}

\begin{task}
  Using the \texttt{dem.simu.print()} function, display the elapsed time
  of the simulation in the simulation window.
\end{task}

\begin{task}
  What is the role of the \texttt{time\_loop()} function?
\end{task}

\begin{task}
Increase the number of iterations to `2000`.
\end{task}

\begin{manip}
  Watch the video \dltutodem{01}{tuto-01\_correction.mp4}.
\end{manip}

\begin{task}
Based on the video, remove the grain from the center and add 4 grains (1 in each corner).
\end{task}

\begin{task}
  Give initial velocities to the 4 grains to create a collision at the center of the scene as shown in the video.
\end{task}

\begin{info}
At this stage, you should obtain a simulation similar to the video \dltutodem{01}{tuto-01\_correction.mp4}.
\end{info}

\end{document}
